/*
   vMac 0.1 Source
   By Philip Cummins (PC)
   Copyright PC 1997
*/
   
/* vMac Custom Code */

#include <ctype.h>
#include <assert.h>

#include "sysconfi.h"                   // includes/sysconfig.h
#include "sysdeps.h"
#include "config.h"
#include "options.h"

#include "custom2.h"                    // includes/vMac_Custom.h

#include "CPU/machdep/m68k.h"
#include "Memory.h"
#include "memory2.h"                    // includes/memory.h

#include "readcpu.h"
#include "newcpu.h"

#include "IWM.h"
#include "RAM.h"
#include "ROM.h"
#include "RTC.h"
#include "SCC.h"
#include "SCSI.h"
#include "Sony.h"
#include "VIA.h"
#include "Interrup.h"                   // hardware/VIA_Interrupts.h

#include "IBM-VGA.h"

unsigned long specialflags = 0;
int InterruptNo = -1;

void MacInterrupt (void)
{	   
   Exception(28,0);
}

void MacReset (void)
{
   m68k_reset();
}

int custominit (void)
{
   int Err = 0;
   Err += RAM_Init();
   Err += ROM_Init();
   Err += IWM_Init();
   Err += SCC_Init();
   Err += SCSI_Init();
   Err += VIA_Init();
   Err += RTC_Init();
   Err += Memory_Init();
//   Err += Screen_Init();
   Err += VGA_VRAMInit();
   Err += Interrupt_Init();
   Err += Sony_Init();
   InterruptNo = -1;
   return Err;
}

void customreset (void)
{
   RAM_Reset();
   ROM_Reset();
   IWM_Reset();
   SCC_Reset();
   SCSI_Reset();
   VIA_Reset();
   RTC_Reset();
   Memory_Init();
//   Screen_Reset();
   VGA_VRAMInit();
   Interrupt_Reset();
   Sony_Reset();
   InterruptNo = -1;
}
