/*
 *  IBM Modem/Printer device drivers
 *
 *  (c) 1998, Yoav Shadmi
 */

// PRINTER PORT
#define LPT1    0x01
#define LPT2    0x02
#define LPT3    0x03

typedef struct {
   UBYTE       PrinterStatus; 
} PAR_STATUS;

typedef struct {
   UWORD       PortNumber;
   PAR_STATUS  PortStatus;
} PAR_HANDLE;

PAR_HANDLE Printer_InitPort   (UWORD Port_Number);
int        Printer_WritePort  (PAR_HANDLE PortHandle, UBYTE character);
void       Printer_GetPort    (PAR_HANDLE PortHandle);
void       Printer_LockDriver (void);

// MODEM PORT
#define COM1    0x00
#define COM2    0x01
#define COM3    0x02
#define COM4    0x03

typedef struct {
   UWORD       BaudRate;
   UBYTE       Parity;
   UBYTE       StopBits;
   UBYTE       DataBits;
} SER_PARAMS;

typedef struct {
   UBYTE       LineStatus;
   UBYTE       ModemStatus;
} SER_STATUS;

typedef struct {
   UWORD       PortNumber;
   SER_PARAMS  PortParams;
   SER_STATUS  PortStatus;
} SER_HANDLE;

SER_HANDLE Modem_InitPort    (UWORD Port_Number, UWORD BaudRate, UBYTE Parity, UBYTE StopBits, UBYTE DataBits);
int        Modem_WritePort   (SER_HANDLE PortHandle, UBYTE character);
UBYTE      Modem_ReadPort    (SER_HANDLE PortHandle, int result);
void       Modem_GetPort     (SER_HANDLE PortHandle);
void       Modem_ReinitPort  (SER_HANDLE PortHandle);
void       Modem_LockDriver  (void);
