/* vMac 0.1 Source
   By Philip Cummins (PC)
   Copyright PC 1997 */

/* PC - Interrupt Functions */

#include "sysconfi.h"                   // includes/sysconfig.h
#include "sysdeps.h"
#include "config.h"
#include "custom2.h"                    // includes/vMac_custom.h
#include "VIA.h"
#include "Interrup.h"                   // hardware/VIA_interrupts.h
#include "Interfac.h"                   // hardware/VIA_interface.h
#include "Screen.h"
#include "RTC.h"
#include "SCC.h"
#include "Mouse.h"
#include "Sony.h"
#include "scsi.h"
#include "debug.h"
#include "prefs.h"
#include "Unix/universa.h"              // unix/universal.h

#include "IBM-SND.h"
#include "IBM-TIME.h"
#include "IBM-VGA.h"

#include <dos.h>

unsigned long int Instruction_Counter = 0;
volatile int skip_count = 0;
volatile int buttonstate;
volatile int draw=0;
static int VBL_Counter = 0;
static long int Mouse_Counter = 0;
static int VIA_Counter = 0;
static long int ClockTick = 0;
static long int OldClockTick = 0;
UBYTE VBL = 0;
unsigned long int Instrucs;
unsigned int Update=0;
extern UBYTE CheckSCSI;

volatile void Int_Handler (void);
volatile void Handler_End (void);

int Interrupt_Init (void)
{
   Instruction_Counter = 0;
   VIA_Counter = 0;
   Mouse_Counter = 0;
   VBL_Counter = 0;
   VBL = 0;

   return 0;
}

void Interrupt_Reset (void)
{
   (void) Interrupt_Init();
}

inline void Interrupt_Timing (void)
{
   // Clock = 7833600 Hz (7.8336 mHz)
   // At best, we can get 3916800 instructions per second
   // Normally, it's probably a lot lower than that, say
   // 783360 instructions/sec if there's 10 cycles per instr.
              
   // skip memory test
   if (thePrefs.Skip) {
      if (skip_count<30) {
         buttonstate=1;
      } else {
         if (skip_count>30 && skip_count<35) {
            buttonstate=0;
         } else {
            buttonstate=buttonstate;
         }
      }  
   }

   if (CheckSCSI) {
      SCSI_Check();
      CheckSCSI=0;
   }

   if (IntVBL) {
      ++skip_count;
      IntVBL = 0;

      if (++VIA_Counter == 4) {
         VIA_Counter = 0;
         VIA_Timer();
      }

      if (thePrefs.VBL) {
         while (inportb(0x3DA) & 8);          // Sync. vMac to host VBL
      }

      if (thePrefs.Sound) Sound_Play();
      VIA_Int(Vertical_Blanking);

      SCC_Int();

      if (IntSEC) {
         IntSEC = 0;

         Sony_Update();
         RTC_Interrupt();
         VIA_Int(One_Second);
      }
   }
   return;
}
