/*
   keyboard.h
   keyboard definitions

   (c) Yoav Shadmi, 1998
*/

#define SC_ESC 0xFFFE
#define SC_CTR 0xFFFD
#define SC_ALT 0xFFFC
#define SC_SFT 0xFFFB
#define SC_CLK 0xFFFA

int IBM2Mac_reg [128] = {
//           ESC      1       2       3       4       5       6
   0xFFFF, 0x351B, 0x1231, 0x1332, 0x1433, 0x1534, 0x1735, 0x1636,
//    7       8       9       0       -       =       BS     TAB
   0x1A37, 0x1C38, 0x1939, 0x1D30, 0x1B2D, 0x183D, 0x3308, 0x3009,
//    Q       W       E       R       T       Y       U       I
   0x0C71, 0x0D77, 0x0E65, 0x0F72, 0x1174, 0x1079, 0x2075, 0x2269,
//    O       P       [       ]     RTRN    CTRL      A       S
   0x1F6F, 0x2370, 0x215B, 0x1E5D, 0x490D, SC_CTR, 0x0061, 0x0173,
//    D       F       G       H       J       K       L       ;
   0x0264, 0x0366, 0x0567, 0x0468, 0x266A, 0x286B, 0x256C, 0x293B,
//    '       `     SHFT      \       Z       X       C       V
   0x2727, 0x3260, SC_SFT, 0x2A5C, 0x067A, 0x0778, 0x0863, 0x0976,
//    B       N       M       ,       .       /     SHFT     KP*
   0x0B62, 0x2D6E, 0x2E6D, 0x2B2C, 0x2F2E, 0x2C2F, SC_SFT, 0x9C2A,
//   ALT     SPAC    CAPS     F1      F2      F3      F4      F5
   SC_ALT, 0x3120, SC_CLK, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
//    F6      F7      F8      F9     F10     NUM     SCRL    KP7
   0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x5937,
//   KP8     KP9     KP-     KP4     KP5     KP6     KP+     KP1
   0x5B38, 0x5C39, 0x1B2D, 0x5634, 0x5735, 0x5836, 0x982B, 0x5331,
//   KP2     KP3     KP0     KP.    SREQ       
   0x5432, 0x5533, 0x5230, 0x2F2E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
//
   0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
//   RTRN    CTRL     /              ALT                      UP
   0x490D, SC_CTR, 0x2C2F, 0xFFFF, SC_ALT, 0xFFFF, 0xFFFF, 0x4D1E,
//            LT      RT              DN
   0xFFFF, 0x461C, 0x421D, 0xFFFF, 0x481F, 0xFFFF, 0xFFFF, 0xFFFF,
//
   0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
//
   0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

#define _KEY_UP   0
#define _KEY_DOWN 1
#define _KEY_AUTO 2

#define _NUMLOCK 0x45
#define _CAPSLCK 0x3A
#define _SCRLLCK 0x46
#define _F1      59
#define _F2      60
#define _F3      61
#define _F4      62
#define _F5      63
#define _F6      64
#define _F7      65
#define _F8      66
#define _F9      67
#define _F10     68
#define _F11     87
#define _F12     88

#define _LALT     56
#define _RALT     100
#define _LCTRL    29
#define _RCTRL    97
#define _LSHIFT   0x2A
#define _RSHIFT   0x36

#define _Space    
